stages:
  - prepare
  - test
  - centralize
  - deploy

# prepare
prepare:initialization:
  stage: prepare
  tags:
    - ci-auctus
    - u180464b
  script:
    - echo ci | sudo -S mv /usr/local/lib/libexpat.so.1.5.2 /usr/local/lib/libexpat.so.1.5.2.bak && echo $?;echo $?;
  allow_failure: true
  
# analysis
analysis:coverage:
  stage: test
  tags:
    - ci-auctus
    - u180464b
  script:
    - mkdir -p analysis/gcov
    - source catkin_ws/devel/setup.bash
    - python3 src/osim2urdf_parser.py || echo exit code $?
    - timeout 10s roslaunch human_control human_control.launch || echo exit code $?
    - python3 src/comparison_pin_urdf_os_osim.py || echo exit code $?
    - gcovr --filter="/home/*" --root="$PWD" --xml-pretty --object-directory="$PWD/catkin_ws/build" --output="analysis/coverage.xml"
  dependencies:
    - build:debug:u180464b
  artifacts:
    paths:
      - analysis
      - catkin_ws/devel
      - catkin_ws/src      
  allow_failure: true
  
sonarqube:
  stage: centralize
  dependencies:
    - analysis:coverage
    - analysis:static
  tags:
    - ci-auctus
    - u180464b
  script:
    - export PATH=$PATH:/opt/sonar-scanner/bin
    - sonar-scanner
    
# documentation deployment
pages:
  stage: deploy
  tags:
    - ci-auctus
    - u180464b
  script:
    - doxygen Doxyfile
    - mv html/ public/
  artifacts:
    paths:
      - public
  dependencies:
    - sonarqube
  only:
    - master

